﻿Imports System
Imports System.Threading
Imports System.IO.Ports

Public Class Form1

    Const BUF_SIZE As Integer = 128
    Const FIFO_SIZE As Integer = 128

    Const GPIO_OK As Integer = 0
    Const GPIO_INVALID_HANDLE As Integer = 1
    Const GPIO_COMMAND_ERROR As Integer = 2
    Const GPIO_IO_ERROR As Integer = 3
    Const GPIO_TIMEOUT As Integer = 4
    Const GPIO_BUSY As Integer = 5
    Const GPIO_OTHER_ERROR As Integer = 6
    Const GPIO_H_LEVEL As Integer = 7
    Const GPIO_L_LEVEL As Integer = 8

    Private Declare Function ScanIF Lib "gpio_dll.dll" Alias "GPIO_ScanInterface" (ByVal comPort As Byte()) As Integer
    Private Declare Function OpenIF Lib "gpio_dll.dll" Alias "GPIO_OpenInterface" (ByVal comPort As Byte(), ByRef gpioHandle As Integer) As Integer
    Private Declare Function CloseIF Lib "gpio_dll.dll" Alias "GPIO_CloseInterface" (ByVal gpioHandle As Integer) As Integer
    Private Declare Function ReadPort Lib "gpio_dll.dll" Alias "GPIO_Input" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByRef pucData As Byte) As Integer
    Private Declare Function WritePort Lib "gpio_dll.dll" Alias "GPIO_Output" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByVal ucData As Byte) As Integer
    Private Declare Function TestBit Lib "gpio_dll.dll" Alias "GPIO_BitTest" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByVal ucBit As Byte) As Integer
    Private Declare Function SetBit Lib "gpio_dll.dll" Alias "GPIO_BitSet" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByVal ucBit As Byte) As Integer
    Private Declare Function ResetBit Lib "gpio_dll.dll" Alias "GPIO_BitReset" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByVal ucBit As Byte) As Integer
    Private Declare Function GetVersion Lib "gpio_dll.dll" Alias "GPIO_GetVersion" (ByVal gpioHandle As Integer, ByVal pucBuffer() As Byte, ByVal iBufferSize As Integer) As Integer

    Public comPort(64) As Byte
    Dim ifHndl As Long


    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim stc As Integer
        Dim buf(BUF_SIZE) As Byte

        stc = ScanIF(comPort)                               ' Scan Interface
        If (comPort(0) = Asc("C")) Then
            stc = OpenIF(comPort, ifHndl)                   ' Open Interface
            If (stc = GPIO_OK) And (ifHndl <> 0) Then
                stc = GetVersion(ifHndl, buf, BUF_SIZE)     ' Get Interface Version
            End If
        End If

        Thread.Sleep(1000)
        Timer1.Enabled = True

    End Sub


    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick

        Dim stc As Integer
        Dim dt(4) As Byte

        stc = ReadPort(ifHndl, Asc("A"), dt(0))
        TextBox1.Text = dt(0).ToString("X2")

        stc = ReadPort(ifHndl, Asc("B"), dt(1))
        TextBox2.Text = dt(1).ToString("X2")

        stc = ReadPort(ifHndl, Asc("C"), dt(2))
        TextBox3.Text = dt(2).ToString("X2")

        stc = ReadPort(ifHndl, Asc("D"), dt(3))
        TextBox4.Text = dt(3).ToString("X2")

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("C"), 7)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("C"), 7)
        Else
            stc = ResetBit(ifHndl, Asc("C"), 7)
        End If

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("C"), 6)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("C"), 6)
        Else
            stc = ResetBit(ifHndl, Asc("C"), 6)
        End If

    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("C"), 5)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("C"), 5)
        Else
            stc = ResetBit(ifHndl, Asc("C"), 5)
        End If

    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("C"), 4)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("C"), 4)
        Else
            stc = ResetBit(ifHndl, Asc("C"), 4)
        End If

    End Sub

    Private Sub Button8_Click(sender As Object, e As EventArgs) Handles Button8.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("C"), 3)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("C"), 3)
        Else
            stc = ResetBit(ifHndl, Asc("C"), 3)
        End If

    End Sub

    Private Sub Button7_Click(sender As Object, e As EventArgs) Handles Button7.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("C"), 2)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("C"), 2)
        Else
            stc = ResetBit(ifHndl, Asc("C"), 2)
        End If

    End Sub

    Private Sub Button6_Click(sender As Object, e As EventArgs) Handles Button6.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("C"), 1)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("C"), 1)
        Else
            stc = ResetBit(ifHndl, Asc("C"), 1)
        End If

    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("C"), 0)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("C"), 0)
        Else
            stc = ResetBit(ifHndl, Asc("C"), 0)
        End If

    End Sub

    Private Sub Button16_Click(sender As Object, e As EventArgs) Handles Button16.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("D"), 7)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("D"), 7)
        Else
            stc = ResetBit(ifHndl, Asc("D"), 7)
        End If

    End Sub

    Private Sub Button15_Click(sender As Object, e As EventArgs) Handles Button15.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("D"), 6)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("D"), 6)
        Else
            stc = ResetBit(ifHndl, Asc("D"), 6)
        End If

    End Sub

    Private Sub Button14_Click(sender As Object, e As EventArgs) Handles Button14.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("D"), 5)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("D"), 5)
        Else
            stc = ResetBit(ifHndl, Asc("D"), 5)
        End If

    End Sub

    Private Sub Button13_Click(sender As Object, e As EventArgs) Handles Button13.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("D"), 4)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("D"), 4)
        Else
            stc = ResetBit(ifHndl, Asc("D"), 4)
        End If

    End Sub

    Private Sub Button12_Click(sender As Object, e As EventArgs) Handles Button12.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("D"), 3)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("D"), 3)
        Else
            stc = ResetBit(ifHndl, Asc("D"), 3)
        End If

    End Sub

    Private Sub Button11_Click(sender As Object, e As EventArgs) Handles Button11.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("D"), 2)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("D"), 2)
        Else
            stc = ResetBit(ifHndl, Asc("D"), 2)
        End If

    End Sub

    Private Sub Button10_Click(sender As Object, e As EventArgs) Handles Button10.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("D"), 1)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("D"), 1)
        Else
            stc = ResetBit(ifHndl, Asc("D"), 1)
        End If

    End Sub

    Private Sub Button9_Click(sender As Object, e As EventArgs) Handles Button9.Click

        Dim stc As Integer

        stc = TestBit(ifHndl, Asc("D"), 0)
        If (stc = GPIO_L_LEVEL) Then
            stc = SetBit(ifHndl, Asc("D"), 0)
        Else
            stc = ResetBit(ifHndl, Asc("D"), 0)
        End If

    End Sub

    Private Sub TextBox5_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TextBox5.KeyPress

        Dim stc As Integer
        Dim stat As Boolean

        If e.KeyChar = vbCr Then                    ' Enterキー
            e.Handled = True                        ' ビープ音消去
            If TextBox5.Text.Length = 1 Or TextBox5.Text.Length = 2 Then
                stat = CheckHexValue(TextBox5.Text)
                If stat = True Then                 ' ここでＩ／Ｏ出力
                    stc = WritePort(ifHndl, Asc("C"), Convert.ToInt32((TextBox5.Text), 16))
                Else                                ' １６進数でない
                    TextBox5.Text = TextBox3.Text
                    Beep()
                End If
            Else                                    ' 桁数異常
                TextBox5.Text = TextBox3.Text
                Beep()
            End If
        ElseIf e.KeyChar = Chr(&H1B) Then           ' ESCキー
            e.Handled = True
            TextBox5.Text = TextBox3.Text           ' 元に戻す
        End If
    End Sub

    Private Sub TextBox6_KeyPress(sender As Object, e As KeyPressEventArgs) Handles TextBox6.KeyPress

        Dim stc As Integer
        Dim stat As Boolean

        If e.KeyChar = vbCr Then                    ' Enterキー
            e.Handled = True                        ' ビープ音消去
            If TextBox6.Text.Length = 1 Or TextBox6.Text.Length = 2 Then
                stat = CheckHexValue(TextBox6.Text)
                If stat = True Then                 ' ここでＩ／Ｏ出力
                    stc = WritePort(ifHndl, Asc("D"), Convert.ToInt32((TextBox6.Text), 16))
                Else                                ' １６進数でない
                    TextBox6.Text = TextBox4.Text
                    Beep()
                End If
            Else                                    ' 桁数異常
                TextBox6.Text = TextBox4.Text
                Beep()
            End If
        ElseIf e.KeyChar = Chr(&H1B) Then           ' ESCキー
            e.Handled = True
            TextBox6.Text = TextBox4.Text           ' 元に戻す
        End If
    End Sub

    Private Function CheckHexValue(ByVal str As String) As Boolean

        Dim b As Integer

        Try
            b = Convert.ToInt32(str, 16)
            CheckHexValue = True
        Catch ex As System.FormatException
            CheckHexValue = False
        End Try

    End Function

End Class
